Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/dataanalysis.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/dataanalysis.cs	(revision 7294)
@@ -817,4 +907,938 @@
         double result = linreg.lravgrelerror(lm.innerobj, xy, npoints);
         return result;
+    }
+
+}
+public partial class alglib
+{
+
+
+    /*************************************************************************
+
+    *************************************************************************/
+    public class multilayerperceptron
+    {
+        //
+        // Public declarations
+        //
+
+        public multilayerperceptron()
+        {
+            _innerobj = new mlpbase.multilayerperceptron();
+        }
+
+        //
+        // Although some of declarations below are public, you should not use them
+        // They are intended for internal use only
+        //
+        private mlpbase.multilayerperceptron _innerobj;
+        public mlpbase.multilayerperceptron innerobj { get { return _innerobj; } }
+        public multilayerperceptron(mlpbase.multilayerperceptron obj)
+        {
+            _innerobj = obj;
+        }
+    }
+
+
+    /*************************************************************************
+    This function serializes data structure to string.
+
+    Important properties of s_out:
+    * it contains alphanumeric characters, dots, underscores, minus signs
+    * these symbols are grouped into words, which are separated by spaces
+      and Windows-style (CR+LF) newlines
+    * although  serializer  uses  spaces and CR+LF as separators, you can 
+      replace any separator character by arbitrary combination of spaces,
+      tabs, Windows or Unix newlines. It allows flexible reformatting  of
+      the  string  in  case you want to include it into text or XML file. 
+      But you should not insert separators into the middle of the "words"
+      nor you should change case of letters.
+    * s_out can be freely moved between 32-bit and 64-bit systems, little
+      and big endian machines, and so on. You can serialize structure  on
+      32-bit machine and unserialize it on 64-bit one (or vice versa), or
+      serialize  it  on  SPARC  and  unserialize  on  x86.  You  can also 
+      serialize  it  in  C# version of ALGLIB and unserialize in C++ one, 
+      and vice versa.
+    *************************************************************************/
+    public static void mlpserialize(multilayerperceptron obj, out string s_out)
+    {
+        alglib.serializer s = new alglib.serializer();
+        s.alloc_start();
+        mlpbase.mlpalloc(s, obj.innerobj);
+        s.sstart_str();
+        mlpbase.mlpserialize(s, obj.innerobj);
+        s.stop();
+        s_out = s.get_string();
+    }
+
+
+    /*************************************************************************
+    This function unserializes data structure from string.
+    *************************************************************************/
+    public static void mlpunserialize(string s_in, out multilayerperceptron obj)
+    {
+        alglib.serializer s = new alglib.serializer();
+        obj = new multilayerperceptron();
+        s.ustart_str(s_in);
+        mlpbase.mlpunserialize(s, obj.innerobj);
+        s.stop();
+    }
+
+    /*************************************************************************
+    Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
+    layers, with linear output layer. Network weights are  filled  with  small
+    random values.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreate0(int nin, int nout, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreate0(nin, nout, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same  as  MLPCreate0,  but  with  one  hidden  layer  (NHid  neurons) with
+    non-linear activation function. Output layer is linear.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreate1(int nin, int nhid, int nout, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreate1(nin, nhid, nout, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreate0, but with two hidden layers (NHid1 and  NHid2  neurons)
+    with non-linear activation function. Output layer is linear.
+     $ALL
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreate2(int nin, int nhid1, int nhid2, int nout, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreate2(nin, nhid1, nhid2, nout, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
+    layers with non-linear output layer. Network weights are filled with small
+    random values.
+
+    Activation function of the output layer takes values:
+
+        (B, +INF), if D>=0
+
+    or
+
+        (-INF, B), if D<0.
+
+
+      -- ALGLIB --
+         Copyright 30.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreateb0(int nin, int nout, double b, double d, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreateb0(nin, nout, b, d, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreateB0 but with non-linear hidden layer.
+
+      -- ALGLIB --
+         Copyright 30.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreateb1(int nin, int nhid, int nout, double b, double d, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreateb1(nin, nhid, nout, b, d, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreateB0 but with two non-linear hidden layers.
+
+      -- ALGLIB --
+         Copyright 30.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreateb2(int nin, int nhid1, int nhid2, int nout, double b, double d, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreateb2(nin, nhid1, nhid2, nout, b, d, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Creates  neural  network  with  NIn  inputs,  NOut outputs, without hidden
+    layers with non-linear output layer. Network weights are filled with small
+    random values. Activation function of the output layer takes values [A,B].
+
+      -- ALGLIB --
+         Copyright 30.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreater0(int nin, int nout, double a, double b, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreater0(nin, nout, a, b, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreateR0, but with non-linear hidden layer.
+
+      -- ALGLIB --
+         Copyright 30.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreater1(int nin, int nhid, int nout, double a, double b, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreater1(nin, nhid, nout, a, b, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreateR0, but with two non-linear hidden layers.
+
+      -- ALGLIB --
+         Copyright 30.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreater2(int nin, int nhid1, int nhid2, int nout, double a, double b, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreater2(nin, nhid1, nhid2, nout, a, b, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Creates classifier network with NIn  inputs  and  NOut  possible  classes.
+    Network contains no hidden layers and linear output  layer  with  SOFTMAX-
+    normalization  (so  outputs  sums  up  to  1.0  and  converge to posterior
+    probabilities).
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreatec0(int nin, int nout, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreatec0(nin, nout, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreateC0, but with one non-linear hidden layer.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreatec1(int nin, int nhid, int nout, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreatec1(nin, nhid, nout, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Same as MLPCreateC0, but with two non-linear hidden layers.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpcreatec2(int nin, int nhid1, int nhid2, int nout, out multilayerperceptron network)
+    {
+        network = new multilayerperceptron();
+        mlpbase.mlpcreatec2(nin, nhid1, nhid2, nout, network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Randomization of neural network weights
+
+      -- ALGLIB --
+         Copyright 06.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlprandomize(multilayerperceptron network)
+    {
+
+        mlpbase.mlprandomize(network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Randomization of neural network weights and standartisator
+
+      -- ALGLIB --
+         Copyright 10.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlprandomizefull(multilayerperceptron network)
+    {
+
+        mlpbase.mlprandomizefull(network.innerobj);
+        return;
+    }
+
+    /*************************************************************************
+    Returns information about initialized network: number of inputs, outputs,
+    weights.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpproperties(multilayerperceptron network, out int nin, out int nout, out int wcount)
+    {
+        nin = 0;
+        nout = 0;
+        wcount = 0;
+        mlpbase.mlpproperties(network.innerobj, ref nin, ref nout, ref wcount);
+        return;
+    }
+
+    /*************************************************************************
+    Tells whether network is SOFTMAX-normalized (i.e. classifier) or not.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static bool mlpissoftmax(multilayerperceptron network)
+    {
+
+        bool result = mlpbase.mlpissoftmax(network.innerobj);
+        return result;
+    }
+
+    /*************************************************************************
+    This function returns total number of layers (including input, hidden and
+    output layers).
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static int mlpgetlayerscount(multilayerperceptron network)
+    {
+
+        int result = mlpbase.mlpgetlayerscount(network.innerobj);
+        return result;
+    }
+
+    /*************************************************************************
+    This function returns size of K-th layer.
+
+    K=0 corresponds to input layer, K=CNT-1 corresponds to output layer.
+
+    Size of the output layer is always equal to the number of outputs, although
+    when we have softmax-normalized network, last neuron doesn't have any
+    connections - it is just zero.
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static int mlpgetlayersize(multilayerperceptron network, int k)
+    {
+
+        int result = mlpbase.mlpgetlayersize(network.innerobj, k);
+        return result;
+    }
+
+    /*************************************************************************
+    This function returns offset/scaling coefficients for I-th input of the
+    network.
+
+    INPUT PARAMETERS:
+        Network     -   network
+        I           -   input index
+
+    OUTPUT PARAMETERS:
+        Mean        -   mean term
+        Sigma       -   sigma term, guaranteed to be nonzero.
+
+    I-th input is passed through linear transformation
+        IN[i] = (IN[i]-Mean)/Sigma
+    before feeding to the network
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgetinputscaling(multilayerperceptron network, int i, out double mean, out double sigma)
+    {
+        mean = 0;
+        sigma = 0;
+        mlpbase.mlpgetinputscaling(network.innerobj, i, ref mean, ref sigma);
+        return;
+    }
+
+    /*************************************************************************
+    This function returns offset/scaling coefficients for I-th output of the
+    network.
+
+    INPUT PARAMETERS:
+        Network     -   network
+        I           -   input index
+
+    OUTPUT PARAMETERS:
+        Mean        -   mean term
+        Sigma       -   sigma term, guaranteed to be nonzero.
+
+    I-th output is passed through linear transformation
+        OUT[i] = OUT[i]*Sigma+Mean
+    before returning it to user. In case we have SOFTMAX-normalized network,
+    we return (Mean,Sigma)=(0.0,1.0).
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgetoutputscaling(multilayerperceptron network, int i, out double mean, out double sigma)
+    {
+        mean = 0;
+        sigma = 0;
+        mlpbase.mlpgetoutputscaling(network.innerobj, i, ref mean, ref sigma);
+        return;
+    }
+
+    /*************************************************************************
+    This function returns information about Ith neuron of Kth layer
+
+    INPUT PARAMETERS:
+        Network     -   network
+        K           -   layer index
+        I           -   neuron index (within layer)
+
+    OUTPUT PARAMETERS:
+        FKind       -   activation function type (used by MLPActivationFunction())
+                        this value is zero for input or linear neurons
+        Threshold   -   also called offset, bias
+                        zero for input neurons
+
+    NOTE: this function throws exception if layer or neuron with  given  index
+    do not exists.
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgetneuroninfo(multilayerperceptron network, int k, int i, out int fkind, out double threshold)
+    {
+        fkind = 0;
+        threshold = 0;
+        mlpbase.mlpgetneuroninfo(network.innerobj, k, i, ref fkind, ref threshold);
+        return;
+    }
+
+    /*************************************************************************
+    This function returns information about connection from I0-th neuron of
+    K0-th layer to I1-th neuron of K1-th layer.
+
+    INPUT PARAMETERS:
+        Network     -   network
+        K0          -   layer index
+        I0          -   neuron index (within layer)
+        K1          -   layer index
+        I1          -   neuron index (within layer)
+
+    RESULT:
+        connection weight (zero for non-existent connections)
+
+    This function:
+    1. throws exception if layer or neuron with given index do not exists.
+    2. returns zero if neurons exist, but there is no connection between them
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpgetweight(multilayerperceptron network, int k0, int i0, int k1, int i1)
+    {
+
+        double result = mlpbase.mlpgetweight(network.innerobj, k0, i0, k1, i1);
+        return result;
+    }
+
+    /*************************************************************************
+    This function sets offset/scaling coefficients for I-th input of the
+    network.
+
+    INPUT PARAMETERS:
+        Network     -   network
+        I           -   input index
+        Mean        -   mean term
+        Sigma       -   sigma term (if zero, will be replaced by 1.0)
+
+    NTE: I-th input is passed through linear transformation
+        IN[i] = (IN[i]-Mean)/Sigma
+    before feeding to the network. This function sets Mean and Sigma.
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpsetinputscaling(multilayerperceptron network, int i, double mean, double sigma)
+    {
+
+        mlpbase.mlpsetinputscaling(network.innerobj, i, mean, sigma);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets offset/scaling coefficients for I-th output of the
+    network.
+
+    INPUT PARAMETERS:
+        Network     -   network
+        I           -   input index
+        Mean        -   mean term
+        Sigma       -   sigma term (if zero, will be replaced by 1.0)
+
+    OUTPUT PARAMETERS:
+
+    NOTE: I-th output is passed through linear transformation
+        OUT[i] = OUT[i]*Sigma+Mean
+    before returning it to user. This function sets Sigma/Mean. In case we
+    have SOFTMAX-normalized network, you can not set (Sigma,Mean) to anything
+    other than(0.0,1.0) - this function will throw exception.
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpsetoutputscaling(multilayerperceptron network, int i, double mean, double sigma)
+    {
+
+        mlpbase.mlpsetoutputscaling(network.innerobj, i, mean, sigma);
+        return;
+    }
+
+    /*************************************************************************
+    This function modifies information about Ith neuron of Kth layer
+
+    INPUT PARAMETERS:
+        Network     -   network
+        K           -   layer index
+        I           -   neuron index (within layer)
+        FKind       -   activation function type (used by MLPActivationFunction())
+                        this value must be zero for input neurons
+                        (you can not set activation function for input neurons)
+        Threshold   -   also called offset, bias
+                        this value must be zero for input neurons
+                        (you can not set threshold for input neurons)
+
+    NOTES:
+    1. this function throws exception if layer or neuron with given index do
+       not exists.
+    2. this function also throws exception when you try to set non-linear
+       activation function for input neurons (any kind of network) or for output
+       neurons of classifier network.
+    3. this function throws exception when you try to set non-zero threshold for
+       input neurons (any kind of network).
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpsetneuroninfo(multilayerperceptron network, int k, int i, int fkind, double threshold)
+    {
+
+        mlpbase.mlpsetneuroninfo(network.innerobj, k, i, fkind, threshold);
+        return;
+    }
+
+    /*************************************************************************
+    This function modifies information about connection from I0-th neuron of
+    K0-th layer to I1-th neuron of K1-th layer.
+
+    INPUT PARAMETERS:
+        Network     -   network
+        K0          -   layer index
+        I0          -   neuron index (within layer)
+        K1          -   layer index
+        I1          -   neuron index (within layer)
+        W           -   connection weight (must be zero for non-existent
+                        connections)
+
+    This function:
+    1. throws exception if layer or neuron with given index do not exists.
+    2. throws exception if you try to set non-zero weight for non-existent
+       connection
+
+      -- ALGLIB --
+         Copyright 25.03.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpsetweight(multilayerperceptron network, int k0, int i0, int k1, int i1, double w)
+    {
+
+        mlpbase.mlpsetweight(network.innerobj, k0, i0, k1, i1, w);
+        return;
+    }
+
+    /*************************************************************************
+    Neural network activation function
+
+    INPUT PARAMETERS:
+        NET         -   neuron input
+        K           -   function index (zero for linear function)
+
+    OUTPUT PARAMETERS:
+        F           -   function
+        DF          -   its derivative
+        D2F         -   its second derivative
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpactivationfunction(double net, int k, out double f, out double df, out double d2f)
+    {
+        f = 0;
+        df = 0;
+        d2f = 0;
+        mlpbase.mlpactivationfunction(net, k, ref f, ref df, ref d2f);
+        return;
+    }
+
+    /*************************************************************************
+    Procesing
+
+    INPUT PARAMETERS:
+        Network -   neural network
+        X       -   input vector,  array[0..NIn-1].
+
+    OUTPUT PARAMETERS:
+        Y       -   result. Regression estimate when solving regression  task,
+                    vector of posterior probabilities for classification task.
+
+    See also MLPProcessI
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpprocess(multilayerperceptron network, double[] x, ref double[] y)
+    {
+
+        mlpbase.mlpprocess(network.innerobj, x, ref y);
+        return;
+    }
+
+    /*************************************************************************
+    'interactive'  variant  of  MLPProcess  for  languages  like  Python which
+    support constructs like "Y = MLPProcess(NN,X)" and interactive mode of the
+    interpreter
+
+    This function allocates new array on each call,  so  it  is  significantly
+    slower than its 'non-interactive' counterpart, but it is  more  convenient
+    when you call it from command line.
+
+      -- ALGLIB --
+         Copyright 21.09.2010 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpprocessi(multilayerperceptron network, double[] x, out double[] y)
+    {
+        y = new double[0];
+        mlpbase.mlpprocessi(network.innerobj, x, ref y);
+        return;
+    }
+
+    /*************************************************************************
+    Error function for neural network, internal subroutine.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlperror(multilayerperceptron network, double[,] xy, int ssize)
+    {
+
+        double result = mlpbase.mlperror(network.innerobj, xy, ssize);
+        return result;
+    }
+
+    /*************************************************************************
+    Natural error function for neural network, internal subroutine.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlperrorn(multilayerperceptron network, double[,] xy, int ssize)
+    {
+
+        double result = mlpbase.mlperrorn(network.innerobj, xy, ssize);
+        return result;
+    }
+
+    /*************************************************************************
+    Classification error
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static int mlpclserror(multilayerperceptron network, double[,] xy, int ssize)
+    {
+
+        int result = mlpbase.mlpclserror(network.innerobj, xy, ssize);
+        return result;
+    }
+
+    /*************************************************************************
+    Relative classification error on the test set
+
+    INPUT PARAMETERS:
+        Network -   network
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        percent of incorrectly classified cases. Works both for
+        classifier networks and general purpose networks used as
+        classifiers.
+
+      -- ALGLIB --
+         Copyright 25.12.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlprelclserror(multilayerperceptron network, double[,] xy, int npoints)
+    {
+
+        double result = mlpbase.mlprelclserror(network.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Average cross-entropy (in bits per element) on the test set
+
+    INPUT PARAMETERS:
+        Network -   neural network
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        CrossEntropy/(NPoints*LN(2)).
+        Zero if network solves regression task.
+
+      -- ALGLIB --
+         Copyright 08.01.2009 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpavgce(multilayerperceptron network, double[,] xy, int npoints)
+    {
+
+        double result = mlpbase.mlpavgce(network.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    RMS error on the test set
+
+    INPUT PARAMETERS:
+        Network -   neural network
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        root mean square error.
+        Its meaning for regression task is obvious. As for
+        classification task, RMS error means error when estimating posterior
+        probabilities.
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlprmserror(multilayerperceptron network, double[,] xy, int npoints)
+    {
+
+        double result = mlpbase.mlprmserror(network.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Average error on the test set
+
+    INPUT PARAMETERS:
+        Network -   neural network
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        Its meaning for regression task is obvious. As for
+        classification task, it means average error when estimating posterior
+        probabilities.
+
+      -- ALGLIB --
+         Copyright 11.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpavgerror(multilayerperceptron network, double[,] xy, int npoints)
+    {
+
+        double result = mlpbase.mlpavgerror(network.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Average relative error on the test set
+
+    INPUT PARAMETERS:
+        Network -   neural network
+        XY      -   test set
+        NPoints -   test set size
+
+    RESULT:
+        Its meaning for regression task is obvious. As for
+        classification task, it means average relative error when estimating
+        posterior probability of belonging to the correct class.
+
+      -- ALGLIB --
+         Copyright 11.03.2008 by Bochkanov Sergey
+    *************************************************************************/
+    public static double mlpavgrelerror(multilayerperceptron network, double[,] xy, int npoints)
+    {
+
+        double result = mlpbase.mlpavgrelerror(network.innerobj, xy, npoints);
+        return result;
+    }
+
+    /*************************************************************************
+    Gradient calculation
+
+    INPUT PARAMETERS:
+        Network -   network initialized with one of the network creation funcs
+        X       -   input vector, length of array must be at least NIn
+        DesiredY-   desired outputs, length of array must be at least NOut
+        Grad    -   possibly preallocated array. If size of array is smaller
+                    than WCount, it will be reallocated. It is recommended to
+                    reuse previously allocated array to reduce allocation
+                    overhead.
+
+    OUTPUT PARAMETERS:
+        E       -   error function, SUM(sqr(y[i]-desiredy[i])/2,i)
+        Grad    -   gradient of E with respect to weights of network, array[WCount]
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgrad(multilayerperceptron network, double[] x, double[] desiredy, out double e, ref double[] grad)
+    {
+        e = 0;
+        mlpbase.mlpgrad(network.innerobj, x, desiredy, ref e, ref grad);
+        return;
+    }
+
+    /*************************************************************************
+    Gradient calculation (natural error function is used)
+
+    INPUT PARAMETERS:
+        Network -   network initialized with one of the network creation funcs
+        X       -   input vector, length of array must be at least NIn
+        DesiredY-   desired outputs, length of array must be at least NOut
+        Grad    -   possibly preallocated array. If size of array is smaller
+                    than WCount, it will be reallocated. It is recommended to
+                    reuse previously allocated array to reduce allocation
+                    overhead.
+
+    OUTPUT PARAMETERS:
+        E       -   error function, sum-of-squares for regression networks,
+                    cross-entropy for classification networks.
+        Grad    -   gradient of E with respect to weights of network, array[WCount]
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgradn(multilayerperceptron network, double[] x, double[] desiredy, out double e, ref double[] grad)
+    {
+        e = 0;
+        mlpbase.mlpgradn(network.innerobj, x, desiredy, ref e, ref grad);
+        return;
+    }
+
+    /*************************************************************************
+    Batch gradient calculation for a set of inputs/outputs
+
+    INPUT PARAMETERS:
+        Network -   network initialized with one of the network creation funcs
+        XY      -   set of inputs/outputs; one sample = one row;
+                    first NIn columns contain inputs,
+                    next NOut columns - desired outputs.
+        SSize   -   number of elements in XY
+        Grad    -   possibly preallocated array. If size of array is smaller
+                    than WCount, it will be reallocated. It is recommended to
+                    reuse previously allocated array to reduce allocation
+                    overhead.
+
+    OUTPUT PARAMETERS:
+        E       -   error function, SUM(sqr(y[i]-desiredy[i])/2,i)
+        Grad    -   gradient of E with respect to weights of network, array[WCount]
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgradbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad)
+    {
+        e = 0;
+        mlpbase.mlpgradbatch(network.innerobj, xy, ssize, ref e, ref grad);
+        return;
+    }
+
+    /*************************************************************************
+    Batch gradient calculation for a set of inputs/outputs
+    (natural error function is used)
+
+    INPUT PARAMETERS:
+        Network -   network initialized with one of the network creation funcs
+        XY      -   set of inputs/outputs; one sample = one row;
+                    first NIn columns contain inputs,
+                    next NOut columns - desired outputs.
+        SSize   -   number of elements in XY
+        Grad    -   possibly preallocated array. If size of array is smaller
+                    than WCount, it will be reallocated. It is recommended to
+                    reuse previously allocated array to reduce allocation
+                    overhead.
+
+    OUTPUT PARAMETERS:
+        E       -   error function, sum-of-squares for regression networks,
+                    cross-entropy for classification networks.
+        Grad    -   gradient of E with respect to weights of network, array[WCount]
+
+      -- ALGLIB --
+         Copyright 04.11.2007 by Bochkanov Sergey
+    *************************************************************************/
+    public static void mlpgradnbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad)
+    {
+        e = 0;
+        mlpbase.mlpgradnbatch(network.innerobj, xy, ssize, ref e, ref grad);
+        return;
+    }
+
+    /*************************************************************************
+    Batch Hessian calculation (natural error function) using R-algorithm.
+    Internal subroutine.
+
+      -- ALGLIB --
+         Copyright 26.01.2008 by Bochkanov Sergey.
+
+         Hessian calculation based on R-algorithm described in
+         "Fast Exact Multiplication by the Hessian",
+         B. A. Pearlmutter,
+         Neural Computation, 1994.
+    *************************************************************************/
+    public static void mlphessiannbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad, ref double[,] h)
+    {
+        e = 0;
+        mlpbase.mlphessiannbatch(network.innerobj, xy, ssize, ref e, ref grad, ref h);
+        return;
+    }
+
+    /*************************************************************************
+    Batch Hessian calculation using R-algorithm.
+    Internal subroutine.
+
+      -- ALGLIB --
+         Copyright 26.01.2008 by Bochkanov Sergey.
+
+         Hessian calculation based on R-algorithm described in
+         "Fast Exact Multiplication by the Hessian",
+         B. A. Pearlmutter,
+         Neural Computation, 1994.
+    *************************************************************************/
+    public static void mlphessianbatch(multilayerperceptron network, double[,] xy, int ssize, out double e, ref double[] grad, ref double[,] h)
+    {
+        e = 0;
+        mlpbase.mlphessianbatch(network.innerobj, xy, ssize, ref e, ref grad, ref h);
+        return;
     }
 
